
// include libraries:
#include <LiquidCrystal.h>
#include <Wire.h>
#include "SparkFunMPL3115A2.h"

// initialize
MPL3115A2 sensor;
LiquidCrystal lcd(12, 11, 5, 4, 3, 2); // LCD input pins

int state;
int statealt();
int statebar();
int stateshutdown();
//int Rpin        = 11; // LED pin to indicate error or shutdown mode..?

const int switchPin = 8;     // button pin
int buttonState = 0;         // variable for reading button status

void setup() { 
  pinMode(switchPin, INPUT); // will read the button
  lcd.begin(16, 2); // set up LCD's columns / rows
  Serial.begin(9600); // baud rate setting
  Wire.begin();        // join i2c bus (needed for sensor)
  lcd.setCursor(0, 0); //start cursor on LCD screen
  lcd.print("STARTUP"); //indicate reset
  delay(1000);
  sensor.begin(); // start up sensor
  sensor.setOversampleRate(7); // set to the recommended 128
  sensor.enableEventFlags(); // enable all 3 pressure and temp event flags 
}

void loop() {
  // set the cursor to column 0, line 1 (beg at 0)
  
    static int state=1; // initial state is case 1
  // print number of seconds since reset:
  // lcd.print(millis() / 1000);

  lcd.setCursor(0, 0);
  Serial.println(buttonState); 
   
 /* float altitude = sensor.readAltitude();
  lcd.print("Alti(m):");
  lcd.print(altitude, 2);*/
/*
  float altitude = sensor.readAltitudeFt();
  Serial.print(" Altitude(ft):");
  Serial.print(altitude, 2);*/

 // float pressure = sensor.readPressure();
  //lcd.print("Pres(Pa):");
  //lcd.print(pressure, 2);
  
 //lcd.setCursor(0, 1);
  //float temperature = sensor.readTemp();
  //lcd.print("Temp(C):");
  //lcd.print(temperature, 2);

  //float temperature = sensor.readTempF();
  //lcd.print(" Temp(f):");
  //lcd.print(temperature, 2);                  


  switch(state)
  {
    case 1:
    state=stateinit();
    break;

    case 2:
    state=statealt();
    break;

    case 3:
    state=statealtft();
    break;

    case 4:
    state=statebar();
    break;


    default:
    state=stateshutdown();
    break;
  }

}


  int stateinit(){
    lcd.print("..."); delay(100); lcd.setCursor(0, 0);
    lcd.print("....");delay(100); lcd.setCursor(0, 0);
    lcd.print(".....");delay(100); lcd.setCursor(0, 0);
    lcd.print("......");delay(100); lcd.setCursor(0, 0);
    lcd.print(".......");
    delay(500); lcd.setCursor(0, 0);
    lcd.print("Alt mode (masl)   ");
    delay(1000);
    return statealt();
  }

  int statealt(){
          sensor.setModeAltimeter(); // Measure altitude above sea level in meters
          float altitude = sensor.readAltitude();
          lcd.setCursor(0, 0);
          lcd.print("Alti(m): ");
          lcd.print(altitude, 2);
          lcd.setCursor(0, 1);
          float temperature = sensor.readTemp();
          lcd.print("Temp(C): ");
          lcd.print(temperature, 2);

          
          buttonState=digitalRead(switchPin); // see if button is pressed
          if (buttonState==HIGH){ // if yes switch to barometer
              lcd.setCursor(0, 0);
              lcd.print("Switch to ft    ");
              lcd.setCursor(0, 1);
              lcd.print("                 ");
              delay(1000);
              return statealtft();
          }
          if (buttonState==LOW) { // otherwise, stay in altitude state
              return statealt();
          }
          if (temperature <= -40){
            return stateshutdown();
          }
  }

    int statealtft(){
          sensor.setModeAltimeter(); // Measure altitude above sea level in feet
          float altitude = sensor.readAltitudeFt();
          lcd.setCursor(0, 0);
          lcd.print("Alti(ft): ");
          lcd.print(altitude, 2);
          lcd.setCursor(0, 1);
          float temperature = sensor.readTemp();
          lcd.print("Temp(C): ");
          lcd.print(temperature, 2);

          
          buttonState=digitalRead(switchPin); // see if button is pressed
          if (buttonState==HIGH){ // if yes switch to barometer
              lcd.setCursor(0, 0);
              lcd.print("Bar mode        ");
              lcd.setCursor(0, 1);
              lcd.print("                 ");
              delay(1000);
              return statebar();
          }
          if (buttonState==LOW) { // otherwise, stay in altitude state
              return statealtft();
          }
          if (temperature <= -40){
            return stateshutdown();
          }
  }

int statebar(){
          sensor.setModeBarometer(); // Measure pressure in Pascals from 20 to 110 kPa
          float pressure = sensor.readPressure();
          lcd.setCursor(0, 0);
          lcd.print("Pres(Pa):");
          lcd.print(pressure, 2);
          lcd.setCursor(0, 1);
          float temperature = sensor.readTemp();
          lcd.print("Temp(C): ");
          lcd.print(temperature, 2);
          
          buttonState=digitalRead(switchPin); // see if button is pressed
          if (buttonState==HIGH){ // if yes switch to altimeter
              lcd.setCursor(0, 0);
              lcd.print("Alt mode (masl)    ");
              lcd.setCursor(0, 1);
              lcd.print("                 ");
              delay(1000);
              return statealt();
          }
          if (buttonState==LOW) { // otherwise, stay in barometer state
            return statebar();
          }
          if (temperature <= -40){
            return stateshutdown();
          }
}

  int stateshutdown(){
        lcd.setCursor(0, 0);
              lcd.print("Temp < op. range");
              lcd.setCursor(0, 1);
              lcd.print("                 ");
                        float temperature = sensor.readTemp();

              if (temperature > -40){
                return statealt();
              }
          }
 

